| XMP Toolkit SDK 6.0.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
AdobeXMPCore::IStructureNode_v1 Class Referenceabstract

Version1 of the interface that represents a structure Node of XMP DOM. More...

`#include <IStructureNode.h>`

Inheritance diagram for AdobeXMPCore::IStructureNode_v1:

## Public Member Functions
virtual eNodeType APICALL | GetChildNodeType (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const =0
| Gets the type of the node's child having specified namespace and name. More...
virtual void APICALL | InsertNode (const spINode &node)=0
| Inserts a given node. More...
virtual spINode APICALL | ReplaceNode (const spINode &node)=0
| Replaces a given node. More...
virtual spINode APICALL | RemoveNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)=0
| Removes the node with the specified nameSpace and name. More...
XMP_PRIVATE spcINode | GetNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Gets the child of the node having specified namespace and name. More...
virtual spINode APICALL | GetNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)=0
XMP_PRIVATE spcISimpleNode | GetSimpleNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Gets the node's child having specified name space and name as simple node. More...
XMP_PRIVATE spISimpleNode | GetSimpleNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
XMP_PRIVATE spcIStructureNode | GetStructureNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Gets the node's child having specified name space and name as structure node. More...
XMP_PRIVATE spIStructureNode | GetStructureNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
XMP_PRIVATE spcIArrayNode | GetArrayNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Gets the node's child having specified name space and name as an array node. More...
XMP_PRIVATE spIArrayNode | GetArrayNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
Public Member Functions inherited from AdobeXMPCore::ICompositeNode_v1
virtual eNodeType APICALL | GetNodeTypeAtPath (const spcIPath &path) const =0
| Get the node type specified by the path relative to the composite node. More...
virtual void APICALL | AppendNode (const spINode &node)=0
| Appends a given node as the child of the node. More...
virtual void APICALL | InsertNodeAtPath (const spINode &node, const spcIPath &path)=0
| Inserts a given node at the path relative to the composite node. More...
virtual spINode APICALL | ReplaceNodeAtPath (const spINode &node, const spcIPath &path)=0
| Replaces an existing node with the given node at the path relative to the composite node.. More...
virtual spINode APICALL | RemoveNodeAtPath (const spcIPath &path)=0
| Removes the node specified by the path relative to the composite node. More...
XMP_PRIVATE spcINode | GetNodeAtPath (const spcIPath &path) const
| Get the node specified by the path relative to the composite node. More...
virtual spINode APICALL | GetNodeAtPath (const spcIPath &path)=0
virtual spINodeIterator APICALL | Iterator ()=0
| Get an iterator object to iterate over all the child nodes of the composite node. More...
XMP_PRIVATE spcINodeIterator | Iterator () const
virtual sizet APICALL | ChildCount () const __NOTHROW__=0
| Get the count of child nodes of the composite node. More...
XMP_PRIVATE spcISimpleNode | GetSimpleNodeAtPath (const spcIPath &path) const
| Get a simple node specified by the path relative to the node. More...
XMP_PRIVATE spISimpleNode | GetSimpleNodeAtPath (const spcIPath &path)
XMP_PRIVATE spcIStructureNode | GetStructureNodeAtPath (const spcIPath &path) const
| Get a structure node specified by the path relative to the node. More...
XMP_PRIVATE spIStructureNode | GetStructureNodeAtPath (const spcIPath &path)
XMP_PRIVATE spcIArrayNode | GetArrayNodeAtPath (const spcIPath &path) const
| Get an array node specified by the path relative to the node. More...
XMP_PRIVATE spIArrayNode | GetArrayNodeAtPath (const spcIPath &path)
Public Member Functions inherited from AdobeXMPCore::INode_v1
virtual eNodeType APICALL | GetNodeType () const =0
| Gets the node type of the node. More...
virtual eNodeType APICALL | GetParentNodeType () const =0
| Gets the node type of the node's parent. More...
virtual void APICALL | SetName (const char *name, sizet nameLength)=0
| Changes the local name of the node. More...
virtual spcIUTF8String APICALL | GetName () const =0
| Gets the local name of the node. More...
virtual void APICALL | SetNameSpace (const char *nameSpace, sizet nameSpaceLength)=0
| Changes the name space of the node. More...
virtual spcIUTF8String APICALL | GetNameSpace () const =0
| Gets the name space of the node. More...
virtual spIPath APICALL | GetPath () const =0
| Gets the path of the node from the root of the metadata. More...
virtual sizet APICALL | QualifiersCount () const __NOTHROW__=0
| Gets the count of the qualifiers attached with the node. More...
virtual eNodeType APICALL | GetQualifierNodeType (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const =0
| Gets the type of the node's qualifier having specified namespace and name. More...
virtual void APICALL | InsertQualifier (const spINode &node)=0
| Inserts a given qualifier node. More...
virtual spINode APICALL | ReplaceQualifier (const spINode &node)=0
| Replaces a given qualifier node. More...
virtual spINode APICALL | RemoveQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)=0
| Removes the qualifier node with the specified nameSpace and name. More...
virtual bool APICALL | IsArrayItem () const =0
| Indicates whether the node is a direct child of an array node. More...
virtual bool APICALL | IsQualifierNode () const =0
| Indicates whether the node is a qualifier node. More...
virtual sizet APICALL | GetIndex () const =0
| Returns the index of the node in case it is an array item. More...
virtual bool APICALL | HasQualifiers () const =0
| Indicates whether the node has any qualifiers associated with it. More...
virtual bool APICALL | HasContent () const =0
| Returns whether the node has any content or not. return A bool value indicating the presence of contents in the node apart from qualifiers. More...
virtual bool APICALL | IsEmpty () const =0
| Returns whether the node is empty. return A bool value indicating whether the contents and qualifiers of a node are empty. More...
virtual bool APICALL | HasChanged () const =0
| Returns the status about any change done to the node or its children or qualifiers. returns a bool value indicating whether some changes have been performed on the node or its children or qualifiers. for a simple node, true will be returned in scenarios like when the node's value or qualifiers are modified. for an array node or a structure node, true will be returned in scenarios like when the node's children or the node's qualifiers are modified. More...
virtual void APICALL | AcknowledgeChanges () const __NOTHROW__=0
| Acknowledges that changes for the node and its children and qualifiers have been taken care of. for a simple node, changes that will be acknowledged in scenarios like when the node's value or node's qualifiers were modified. for an array node or a structure node, changes will be acknowledged in scenarios like when the node's children were or the node's qualifiers were modified. More...
virtual void APICALL | Clear (bool contents=true, bool qualifiers=true)=0
| Clear the contents of the node. More...
virtual spINode APICALL | Clone (bool ignoreEmptyNodes=false, bool ignoreNodesWithOnlyQualifiers=false) const =0
| Virtual copy constructor. More...
XMP_PRIVATE spcINode | GetParent () const
| Gets the parent node of the node. More...
virtual spINode APICALL | GetParent ()=0
XMP_PRIVATE spcINodeIterator | QualifiersIterator () const
virtual spINodeIterator APICALL | QualifiersIterator ()=0
XMP_PRIVATE spcINode | GetQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Gets the qualifier of the node having specified namespace and name. More...
virtual spINode APICALL | GetQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)=0
XMP_PRIVATE spcISimpleNode | GetSimpleQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Get the node's qualifier having specified name space and name as simple node. More...
XMP_PRIVATE spISimpleNode | GetSimpleQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
XMP_PRIVATE spcIStructureNode | GetStructureQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Get the node's qualifier having specified name space and name as structure node. More...
XMP_PRIVATE spIStructureNode | GetStructureQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
XMP_PRIVATE spcIArrayNode | GetArrayQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Get the node's qualifier having specified name space and name as an array node. More...
XMP_PRIVATE spIArrayNode | GetArrayQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
XMP_PRIVATE spcISimpleNode | ConvertToSimpleNode () const
| Converts Node to a simple node, if possible. More...
virtual spISimpleNode APICALL | ConvertToSimpleNode ()=0
XMP_PRIVATE spcIStructureNode | ConvertToStructureNode () const
| Converts Node to a structure node type, if possible. More...
virtual spIStructureNode APICALL | ConvertToStructureNode ()=0
XMP_PRIVATE spcIArrayNode | ConvertToArrayNode () const
| Converts Node to an array node type, if possible. More...
virtual spIArrayNode APICALL | ConvertToArrayNode ()=0
XMP_PRIVATE spcIMetadata | ConvertToMetadata () const
| Converts Node to a metadata node type, if possible. More...
virtual spIMetadata APICALL | ConvertToMetadata ()=0
Public Member Functions inherited from AdobeXMPCommon::ISharedObject
virtual void APICALL | Acquire () const __NOTHROW__=0
| Called by the clients of the object to indicate that he has acquired the shared ownership of the object. More...
virtual void APICALL | Release () const __NOTHROW__=0
| Called by the clients of the object to indicate he has released his shared ownership of the object. If this being the last client than this function should call Destroy to delete and release the memory. More...
Public Member Functions inherited from AdobeXMPCommon::IVersionable
template<typename requestedInterface >
XMP_PRIVATE requestedInterface * | GetInterfacePointer ()
| Get the raw pointer to an interface object implementing the requested version. More...
template<typename requestedInterface >
const XMP_PRIVATE requestedInterface * | GetInterfacePointer () const
| Get the raw pointer to a const interface object implementing the requested version. More...
Public Member Functions inherited from AdobeXMPCommon::IThreadSafe
virtual void APICALL | EnableThreadSafety () const __NOTHROW__=0
| Enables the thread safety on an object. More...
virtual void APICALL | DisableThreadSafety () const __NOTHROW__=0
| Disables the thread safety on an object. More...
virtual bool APICALL | IsThreadSafe () const =0
| Informs whether object can be used across multiple threads or not. More...

## Static Public Member Functions
static XMP_PRIVATE spIStructureNode | CreateStructureNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
| Creates a structure node which is not part of any metadata document. More...

## Protected Member Functions
virtual | ~IStructureNode_v1 () __NOTHROW__
Protected Member Functions inherited from AdobeXMPCore::ICompositeNode_v1
virtual | ~ICompositeNode_v1 () __NOTHROW__
Protected Member Functions inherited from AdobeXMPCore::INode_v1
virtual | ~INode_v1 () __NOTHROW__
Protected Member Functions inherited from AdobeXMPCommon::ISharedObject
virtual | ~ISharedObject () __NOTHROW__=0
| REQ_FRIEND_CLASS_DECLARATION ()
Protected Member Functions inherited from AdobeXMPCommon::IVersionable
virtual | ~IVersionable ()
| REQ_FRIEND_CLASS_DECLARATION ()
Protected Member Functions inherited from AdobeXMPCommon::IThreadSafe
| REQ_FRIEND_CLASS_DECLARATION ()

## Additional Inherited Members
Public Types inherited from AdobeXMPCore::INode_v1
enum | eNodeType { kNTNone = 0, kNTSimple = 1, kNTArray = 1 << 1, kNTStructure = 1 << 2, kNTAll = kAllBits }
| Indicates various types of node available in XMP Data Model like simple, array and structure. More...

## Detailed Description

Version1 of the interface that represents a structure Node of XMP DOM.

Provides all the functions to get and set various properties of the structure node.

Attention
  Support multi threading through locks but can be enabled/disabled by the client. By default every object created does not support multi-threading.

Definition at line 25 of file IStructureNode.h.

## Constructor & Destructor Documentation

## ◆ ~IStructureNode_v1()

virtual AdobeXMPCore::IStructureNode_v1::~IStructureNode_v1 | ( |  | ) |
| inline protected virtual

Destructor

Definition at line 243 of file IStructureNode.h.

243 {}

## Member Function Documentation

## ◆ CreateStructureNode()

static XMP_PRIVATE spIStructureNode AdobeXMPCore::IStructureNode_v1::CreateStructureNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  |
| static

Creates a structure node which is not part of any metadata document.

Parameters

  [in] | nameSpace | Pointer to a constant char buffer containing name space URI of the structure node.
  [in] | nameSpaceLength | Number of characters in nameSpace. In case nameSpace is null terminated set it to AdobeXMPCommon::npos.
  [in] | name | Pointer to a constant char buffer containing local name of the structure node.
  [in] | nameLength | Number of characters in name. In case name is null terminated set it to AdobeXMPCommon::npos.

Returns
  A shared pointer to a AdobeXMPCore::IStructureNode object.

Attention
  Error is thrown in the following cases:
  1. nameSpace is NULL or its contents are empty.
  2. name is NULL or its contents are empty.

## ◆ GetArrayNode() [1/2]

XMP_PRIVATE spIArrayNode AdobeXMPCore::IStructureNode_v1::GetArrayNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  |
| inline

Definition at line 130 of file IStructureNode.h.

130 {
131 auto node = GetNode( nameSpace, nameSpaceLength, name, nameLength );
132 if ( node ) return node->ConvertToArrayNode();
133 return spIArrayNode();
134 }

## ◆ GetArrayNode() [2/2]

XMP_PRIVATE spcIArrayNode AdobeXMPCore::IStructureNode_v1::GetArrayNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  | const
| inline

Gets the node's child having specified name space and name as an array node.

Parameters

  [in] | nameSpace | Pointer to a constant char buffer containing name space URI of the child node.
  [in] | nameSpaceLength | Number of characters in nameSpace. In case nameSpace is null terminated set it to AdobeXMPCommon::npos.
  [in] | name | Pointer to a constant char buffer containing local name of the child node.
  [in] | nameLength | Number of characters in name. In case name is null terminated set it to AdobeXMPCommon::npos.

Returns
  A shared pointer to const or non const ISimpleNode object containing child.

Note
  In case no child exists with the specified nameSpace and name combination then an invalid shared pointer is returned.

Attention
  Error is thrown in case
  - a child exists with the specified nameSpace and name combination but is not an array node.

Definition at line 124 of file IStructureNode.h.

124 {
125 auto node = GetNode( nameSpace, nameSpaceLength, name, nameLength );
126 if ( node ) return node->ConvertToArrayNode();
127 return spcIArrayNode();
128 }

## ◆ GetChildNodeType()

virtual eNodeType APICALL AdobeXMPCore::IStructureNode_v1::GetChildNodeType | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  | const
| pure virtual

Gets the type of the node's child having specified namespace and name.

Parameters

  [in] | nameSpace | Pointer to a constant char buffer containing name space URI of the child node.
  [in] | nameSpaceLength | Number of characters in nameSpace. In case nameSpace is null terminated set it to AdobeXMPCommon::npos.
  [in] | name | Pointer to a constant char buffer containing local name of the child node.
  [in] | nameLength | Number of characters in name. In case name is null terminated set it to AdobeXMPCommon::npos.

Returns
  An object of type eNodeType indicating the type of the node's child.

Note
  In case no child exists with the specified nameSpace and name combination then an eNodeType::kNTNone is returned.

## ◆ GetNode() [1/2]

XMP_PRIVATE spcINode AdobeXMPCore::IStructureNode_v1::GetNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  | const
| inline

Gets the child of the node having specified namespace and name.

Parameters

  [in] | nameSpace | Pointer to a constant char buffer containing name space URI of the child node.
  [in] | nameSpaceLength | Number of characters in nameSpace. In case nameSpace is null terminated set it to AdobeXMPCommon::npos.
  [in] | name | Pointer to a constant char buffer containing local name of the child node.
  [in] | nameLength | Number of characters in name. In case name is null terminated set it to AdobeXMPCommon::npos.

Returns
  A shared pointer to either a const or const child node.

Note
  In case no child exists with the specified nameSpace and name combination then an invalid shared pointer is returned.

Definition at line 53 of file IStructureNode.h.

53 {
54 return const_cast< IStructureNode_v1 * >( this )->GetNode( nameSpace, nameSpaceLength, name, nameLength );
55 }

## ◆ GetNode() [2/2]

virtual spINode APICALL AdobeXMPCore::IStructureNode_v1::GetNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  |
| pure virtual

## ◆ GetSimpleNode() [1/2]

XMP_PRIVATE spISimpleNode AdobeXMPCore::IStructureNode_v1::GetSimpleNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  |
| inline

Definition at line 78 of file IStructureNode.h.

78 {
79 auto node = GetNode( nameSpace, nameSpaceLength, name, nameLength );
80 if ( node ) return node->ConvertToSimpleNode();
81 return spISimpleNode();
82 }

## ◆ GetSimpleNode() [2/2]

XMP_PRIVATE spcISimpleNode AdobeXMPCore::IStructureNode_v1::GetSimpleNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  | const
| inline

Gets the node's child having specified name space and name as simple node.

Parameters

  [in] | nameSpace | Pointer to a constant char buffer containing name space URI of the child node.
  [in] | nameSpaceLength | Number of characters in nameSpace. In case nameSpace is null terminated set it to AdobeXMPCommon::npos.
  [in] | name | Pointer to a constant char buffer containing local name of the child node.
  [in] | nameLength | Number of characters in name. In case name is null terminated set it to AdobeXMPCommon::npos.

Returns
  A shared pointer to const or non const ISimpleNode object containing child.

Note
  In case no child exists with the specified nameSpace and name combination then an invalid shared pointer is returned.

Attention
  Error is thrown in case
  - a child exists with the specified nameSpace and name combination but is not a simple node.

Definition at line 72 of file IStructureNode.h.

72 {
73 auto node = GetNode( nameSpace, nameSpaceLength, name, nameLength );
74 if ( node ) return node->ConvertToSimpleNode();
75 return spcISimpleNode();
76 }

## ◆ GetStructureNode() [1/2]

XMP_PRIVATE spIStructureNode AdobeXMPCore::IStructureNode_v1::GetStructureNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  |
| inline

Definition at line 104 of file IStructureNode.h.

104 {
105 auto node = GetNode( nameSpace, nameSpaceLength, name, nameLength );
106 if ( node ) return node->ConvertToStructureNode();
107 return spIStructureNode();
108 }

## ◆ GetStructureNode() [2/2]

XMP_PRIVATE spcIStructureNode AdobeXMPCore::IStructureNode_v1::GetStructureNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  | const
| inline

Gets the node's child having specified name space and name as structure node.

Parameters

  [in] | nameSpace | Pointer to a constant char buffer containing name space URI of the child node.
  [in] | nameSpaceLength | Number of characters in nameSpace. In case nameSpace is null terminated set it to AdobeXMPCommon::npos.
  [in] | name | Pointer to a constant char buffer containing local name of the child node.
  [in] | nameLength | Number of characters in name. In case name is null terminated set it to AdobeXMPCommon::npos.

Returns
  A shared pointer to const or non const IStructureNode object containing child.

Note
  In case no child exists with the specified nameSpace and name combination then an invalid shared pointer is returned.

Attention
  Error is thrown in case
  - a child exists with the specified nameSpace and name combination but is not a structure node.

Definition at line 98 of file IStructureNode.h.

98 {
99 auto node = GetNode( nameSpace, nameSpaceLength, name, nameLength );
100 if ( node ) return node->ConvertToStructureNode();
101 return spcIStructureNode();
102 }

## ◆ InsertNode()

virtual void APICALL AdobeXMPCore::IStructureNode_v1::InsertNode | ( | const spINode & | node | ) |
| pure virtual

Inserts a given node.

Parameters

  [in] | node | Shared pointer to an object of AdobeXMPCore::INode containing the node to be inserted.

Attention
  Error is thrown in following cases:
  1. given node is invalid.
  2. given node is already a child of some other node.
  3. there exists a node with the same nameSpace and name combination.

## ◆ RemoveNode()

virtual spINode APICALL AdobeXMPCore::IStructureNode_v1::RemoveNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  |
| pure virtual

Removes the node with the specified nameSpace and name.

Parameters

  [in] | nameSpace | Pointer to a constant char buffer containing name space URI of the child node.
  [in] | nameSpaceLength | Number of characters in nameSpace. In case nameSpace is null terminated set it to AdobeXMPCommon::npos.
  [in] | name | Pointer to a constant char buffer containing local name of the child node.
  [in] | nameLength | Number of characters in name. In case name is null terminated set it to AdobeXMPCommon::npos.

Returns
  A shared pointer to AdobeXMPCore::INode object containing node which is removed from the tree.

Note
  In case no node exists with the given nameSpace and name combination an invalid shared pointer is returned.

## ◆ ReplaceNode()

virtual spINode APICALL AdobeXMPCore::IStructureNode_v1::ReplaceNode | ( | const spINode & | node | ) |
| pure virtual

Replaces a given node.

Parameters

  [in] | node | Shared pointer to an object of AdobeXMPCore::INode.

Returns
  A shared pointer to the node being replaced.

Attention
  Error is thrown in following cases:
  1. given node is invalid.
  2. given node is already a child of some other node.
  3. there exists no node with the same nameSpace and name combination.

Note
  Type of the old existing node may/may not be same as that of new node.

The documentation for this class was generated from the following file:

- public/include/XMPCore/Interfaces/IStructureNode.h

AdobeXMPCore::spIStructureNode
shared_ptr< IStructureNode > spIStructureNode
Definition: XMPCoreFwdDeclarations.h:103
AdobeXMPCore::spISimpleNode
shared_ptr< ISimpleNode > spISimpleNode
Definition: XMPCoreFwdDeclarations.h:79
AdobeXMPCore::IStructureNode_v1::GetNode
XMP_PRIVATE spcINode GetNode(const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
Gets the child of the node having specified namespace and name.
Definition: IStructureNode.h:53
AdobeXMPCore::spIArrayNode
shared_ptr< IArrayNode > spIArrayNode
Definition: XMPCoreFwdDeclarations.h:115
AdobeXMPCore::spcISimpleNode
shared_ptr< const ISimpleNode > spcISimpleNode
Definition: XMPCoreFwdDeclarations.h:80
AdobeXMPCore::spcIArrayNode
shared_ptr< const IArrayNode > spcIArrayNode
Definition: XMPCoreFwdDeclarations.h:116
AdobeXMPCore::spcIStructureNode
shared_ptr< const IStructureNode > spcIStructureNode
Definition: XMPCoreFwdDeclarations.h:104